#line 1 "C:/Users/System Administrator/Desktop/mikroC PRO for PIC/Working/Clock/Libstock/One-Wire 40x4 LCD/One-Wire 40x4 LCD.c"
sbit One_Wire at LATA0_bit;
sbit One_Wire_Direction at TRISA0_bit;

void Delay_6ms() {
 Delay_ms(6);
}

void Delay_15us() {
 Delay_us(10);
}

void Send_Byte(char rs, char out_char) {
 char i = 0, mask = 0x80;

 out_char.F1 = rs;

 for(i = 0; i < 7; i++) {
 if(out_char & mask) {
 One_Wire = 0;
 One_Wire = 1;
 Delay_15uS();
 }
 else {
 One_Wire = 0;
 Delay_15uS();
 One_Wire = 1;
 Delay_15uS();
 Delay_15uS();
 }

 mask >>= 1;
 }





 One_Wire = 0;

 Delay_us(210);
 One_Wire = 1;

 Delay_us(300);
}

void Write_Nibbles_1(char rs, char out_char) {
 char data2Send;

 data2Send = out_char & 0xF0;
 data2Send.F3 = 1;
 Delay_us(80);
 data2Send.F2 = 0;
 Send_Byte(rs,data2Send);
 Delay_us(20);
 data2Send.F2 = 1;
 Send_Byte(rs,data2Send);
 Delay_us(80);
 data2Send = out_char & 0x0F;
 data2Send <<= 4;
 data2Send.F3 = 1;
 Delay_us(80);
 data2Send.F2 = 0;
 Send_Byte(rs,data2Send);
 Delay_us(80);
 data2Send.F2 = 1;
 Send_Byte(rs,data2Send);
 Delay_us(80);

}

void Write_Nibbles_2(char rs, char out_char) {
 char data2Send;

 data2Send = out_char & 0xF0;
 data2Send.F2 = 1;
 Delay_us(80);
 data2Send.F3 = 0;
 Send_Byte(rs,data2Send);
 Delay_us(20);
 data2Send.F3 = 1;
 Send_Byte(rs,data2Send);

 data2Send = out_char & 0x0F;
 data2Send <<= 4;
 data2Send.F2 = 1;
 Delay_us(80);
 data2Send.F3 = 0;
 Send_Byte(rs,data2Send);
 Delay_us(80);
 data2Send.F3 = 1;
 Send_Byte(rs,data2Send);
 Delay_us(80);

}

void Write_Nibble_1(char out_char) {
 char data2Send, rs = 0;

 data2Send = out_char & 0xF0;

 data2Send.F2 = 1;
 data2Send.F3 = 1;
 Send_Byte(rs,data2Send);
 Delay_us(200);
 data2Send.F2 = 0;
 Send_Byte(rs,data2Send);
 Delay_us(200);
 data2Send.F2 = 1;
 Send_Byte(rs,data2Send);
}

void Write_Nibble_2(char out_char) {
 char data2Send, rs = 0;

 data2Send = out_char & 0xF0;

 data2Send.F3 = 1;
 data2Send.F2 = 1;
 Send_Byte(rs,data2Send);
 Delay_us(200);
 data2Send.F3 = 0;
 Send_Byte(rs,data2Send);
 Delay_us(200);
 data2Send.F3 = 1;
 Send_Byte(rs,data2Send);
}

void OW_LCD_Init() {
 Delay_ms(150);

 Write_Nibble_1(0x30); Delay_ms(200);
 Write_Nibble_1(0x30); Delay_ms(80);
 Write_Nibble_1(0x30); Delay_ms(80);
 Write_Nibble_1(0x20); Delay_ms(12);
 Write_Nibbles_1(0,0x01); Delay_ms(12);
 Write_Nibbles_1(0,0x28); Delay_ms(4);
 Write_Nibbles_1(0,0x0C); Delay_ms(4);
 Write_Nibbles_1(0,0x06); Delay_ms(4);

 Write_Nibble_2(0x30); Delay_ms(200);
 Write_Nibble_2(0x30); Delay_ms(80);
 Write_Nibble_2(0x30); Delay_ms(80);
 Write_Nibble_2(0x20); Delay_ms(12);
 Write_Nibbles_2(0,0x01); Delay_ms(12);
 Write_Nibbles_2(0,0x28); Delay_ms(4);
 Write_Nibbles_2(0,0x0C); Delay_ms(4);
 Write_Nibbles_2(0,0x06); Delay_ms(4);
}

void OW_LCD_XY_OUT_1(char row, char column) {
 if(row == 1)Write_Nibbles_1(0,128 + column);
 if(row == 2)Write_Nibbles_1(0,192 + column);
 if(row == 3)Write_Nibbles_1(0,148 + column);
 if(row == 4)Write_Nibbles_1(0,212 + column);
 Delay_us(50);
}

void OW_LCD_XY_OUT_2(char row, char column) {
 if(row == 1)Write_Nibbles_2(0,128 + column);
 if(row == 2)Write_Nibbles_2(0,192 + column);
 if(row == 3)Write_Nibbles_2(0,148 + column);
 if(row == 4)Write_Nibbles_2(0,212 + column);
 Delay_us(50);
}

void OW_LCD_Cmd(char out_char) {
 Write_Nibbles_1(0,out_char);
 Write_Nibbles_2(0,out_char);
}

void OW_LCD_Chr(char row, char column, char out_char) {
 if(row < 3) {
 if((row == 1) && (column > 20)){row = 3; column = column - 20;}
 if((row == 2) && (column > 20)){row = 4; column = column - 20;}
 OW_LCD_XY_OUT_1(row,column-1);
 Write_Nibbles_1(1,out_char);
 Delay_us(40);
 }
 else {
 if(row == 3)row = 1;
 if(row == 4)row = 2;
 if((row == 1) && (column > 20)){row = 3; column = column - 20;}
 if((row == 2) && (column > 20)){row = 4; column = column - 20;}
 OW_LCD_XY_OUT_2(row,column-1);
 Write_Nibbles_2(1,out_char);
 Delay_us(40);
 }
}

void OW_LCD_Chr_Cp(char out_char) {
 Write_Nibbles_1(1,out_char);
 Write_Nibbles_2(1,out_char);
 Delay_us(40);
}

void OW_LCD_Out(char row, char column, char *text) {
 while(*text)
 OW_LCD_Chr(row,column++,*text++);
}

void OW_LCD_Out_Cp(char *text) {
 while(*text)
 OW_LCD_Chr_Cp(*text++);
}


char *CopyConst2Ram(char *dest, const char *src) {
 char *d;

 d = dest;
 for(;*dest++ = *src++;);
 return d;
}

const char txt1[] = "I have to connect 40x4 lcd to my project";
const char txt2[] = "The lcd have 2 Enable pins ,";
const char txt3[] = "EN1 for rows 1&2 and EN2 for rows 3&4";
const char txt4[] = "How can I connect it to my Board? ";

char txt[42];

void main() {

 CM1CON0 = 0x00;
 ANSELA = 0x00;
 TRISA = 0x00;
 LATA = 0x01;

 Delay_ms(200);

 OW_LCD_Init();
 OW_LCD_Cmd(_LCD_CURSOR_OFF);
 OW_LCD_Cmd(_LCD_CLEAR);

 OW_LCD_Out(1,1,CopyConst2Ram(txt, txt1));
 OW_LCD_Out(2,1,CopyConst2Ram(txt, txt2));
 OW_LCD_Out(3,1,CopyConst2Ram(txt, txt3));
 OW_LCD_Out(4,1,CopyConst2Ram(txt, txt4));

 while(1) {

 }
}
